#pragma rtGlobals=1		// Use modern global access method.
Function hi_AddWave_panel()

	NewDataFolder :hi_AddWave_temp
	String/G :hi_AddWave_temp:destwave
	String/G :hi_AddWave_temp:srcwave
	
	NewPanel /W=(150,77,480,137)
	DoWindow/C hi_AddWave
	PopupMenu pop_dest title="destination", bodyWidth=200, pos={0,2},size={257,21}, value=WaveList("*",";","MAXLAYERS:0") , proc=hi_AddWave_popup
	PopupMenu pop_src  title="source", bodyWidth=200, pos={22,32},size={235,21},value="choose the destination first" , proc=hi_AddWave_popup
	Button btn_exec, title="execute",pos={270,3},size={50,20}, proc=hi_AddWave_button, disable=2
	Button btn_quit, title="quit",pos={270,33},size={50,20}, proc=hi_AddWave_button
	
End

Function hi_AddWave_core()
	SVAR destwave = :hi_AddWave_temp:destwave
	SVAR srcwave = :hi_AddWave_temp:srcwave
	WAVE wvdest = $destwave
	WAVE wvsrc = $srcwave
	Variable ptsdest
	Variable ptssrc
	Variable i,j
	
	if(WaveDims(wvdest) == 1)
		ptsdest = numpnts(wvdest)
		ptssrc = numpnts(wvsrc)
		InsertPoints ptsdest, ptssrc, wvdest
		for(i=0; i<ptssrc; i+=1)
			wvdest[i+ptsdest] = wvsrc[i]
		endfor
	elseif(WaveDims(wvdest) == 2)
		if(DimSize(wvdest, 0) == DimSize(wvsrc, 0))

			ptsdest = DimSize(wvdest, 1)
			ptssrc = DimSize(wvsrc, 1)

			InsertPoints/M=1 ptsdest, ptssrc, wvdest
			for(i=0; i<ptssrc; i+=1)
				for(j=0; j<DimSize(wvdest, 0); j+=1)
					wvdest[j][i+ptsdest] = wvsrc[j][i]
				endfor
			endfor
			
		elseif(DimSize(wvdest, 1) == DimSize(wvsrc, 1))

			ptsdest = DimSize(wvdest, 0)
			ptssrc = DimSize(wvsrc, 0)

			InsertPoints/M=0 ptsdest, ptssrc, wvdest
			for(i=0; i<ptssrc; i+=1)
				for(j=0; j<DimSize(wvdest, 0); j+=1)
					wvdest[i+ptsdest][j] = wvsrc[i][j]
				endfor
			endfor
		
		
		else
			DoAlert 0, "Matrix size didn't match"
			return -1
		endif

	endif
	
	hi_AddWave_button("btn_quit")
End

Function hi_AddWave_popup (ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum	// which item is currently selected (1-based)
	String popStr		// contents of current popup item as string
	
	if(stringmatch(ctrlName, "pop_dest"))
		SVAR destwave = :hi_AddWave_temp:destwave
		destwave = popStr
		WAVE wv = $popStr
		if(WaveDims(wv) == 1)
			PopupMenu pop_src value=WaveList("*",";","DIMS:1")
		elseif(WaveDims(wv) == 2)	
			PopupMenu pop_src value=WaveList("*",";","DIMS:2")
		endif

	elseif(stringmatch(ctrlName, "pop_src"))
		SVAR srcwave = :hi_AddWave_temp:srcwave
		srcwave = popStr
		Button btn_exec, disable=0
	endif

End


Function hi_AddWave_button (ctrlName) : ButtonControl
	String ctrlName

	if(stringmatch(ctrlName, "btn_quit"))
		DoWindow/K hi_AddWave
		KillDataFolder :hi_AddWave_temp
	elseif(stringmatch(ctrlName, "btn_exec"))
		hi_AddWave_core()
	endif
End