#pragma rtGlobals=1		// Use modern global access method.


Function hi_TweakWave()

	NewDataFolder/O :hi_TweakWave_temp
	String/G :hi_TweakWave_temp:Target = "(all)"
	Variable/G :hi_TweakWave_temp:Operator = 1
	Variable/G :hi_TweakWave_temp:CalcNum = 1

	NewPanel /W=(342,88,627,159)
	DoWindow/C/T/r hi_TweakWave_panel,"tweak the wave ..."	// name, title
	PopupMenu popTarget,pos={5,8},size={54,21},title="target: ", fsize=15, proc=hi_TweakWave_popup
	PopupMenu popTarget,mode=1, value="(all);" + TraceNameList("",";",1)
	PopupMenu popOperator,pos={5,41},size={45,23}, proc=hi_TweakWave_popup
	PopupMenu popOperator,mode=1,popvalue="+",value= #"\"+;-;*;/\""
	SetVariable setvar0,pos={63,44},size={123,18},value=:hi_TweakWave_temp:CalcNum,font="Arial"
	SetVariable setvar0,proc=hi_TweakWave_exec, limits={-inf,inf,0}, title=" "
	Button btnQuit,pos={195,41},size={50,23}, proc=hi_TweakWave_quit, title="quit"

End



Function hi_TweakWave_exec(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName,varStr,varName
	Variable varNum
	SVAR Target = :hi_TweakWave_temp:Target

	if(stringmatch(Target, "(all)"))
		String TargetList = TraceNameList("",";",1)
		String TargetWave
		Variable i = 0
		do
			TargetWave = StringFromList(i, TargetList, ";")

			if(strlen(TargetWave))
				WAVE wv = TraceNameToWaveRef("", TargetWave)
				hi_TweakWave_Operate(wv)
			else
				break
			endif
			i += 1
		while(1)
	else
		WAVE wv = TraceNameToWaveRef("", Target)
		hi_TweakWave_Operate(wv)
	endif
	
End

Function hi_TweakWave_popup(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum	// which item is currently selected (1-based)
	String popStr		// contents of current popup item as string

	if(stringmatch(ctrlName,"popOperator"))
		NVAR Operator = :hi_TweakWave_temp:Operator
		Operator = popNum
	elseif(stringmatch(ctrlName,"popTarget"))
		SVAR Target = :hi_TweakWave_temp:Target
		Target = popStr
	endif
End

Function hi_TweakWave_quit(ctrlName) : ButtonControl
	String ctrlName
	KillDataFolder :hi_TweakWave_temp
	DoWindow/K hi_TweakWave_panel
End

Function hi_TweakWave_Operate(wv)
	// before execution, confirm that the wave 'wv' exists
	WAVE wv
	NVAR Operator = :hi_TweakWave_temp:Operator	
	NVAR CalcNum = :hi_TweakWave_temp:CalcNum
	switch(Operator)
	case 1:		// +
		wv += CalcNum
		break
	case 2:		// -
		wv -= CalcNum
		break
	case 3:		// *
		wv *= CalcNum
		break
	case 4:		// /
		wv /= CalcNum
		break
	default:
		DoAlert 0, "critical error"
	endswitch
	
	
End
